%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   SAR signal processing -- Lab exercise II: SAR Interferometry  Generation of Digital Elevation Model
%   Task 2: Interferogram Generation and Coherence Estimation
%   Basic contents of the source code
%
%   This lab exercise is part of the lecture SAR signal processing given by
%   Richard Bamler and Xiaoxiang Zhu in Beijing IECAS 
%   May 5~9, 2014
%   Remote Sensing Technology 
%   German Aerospace Center (DLR) & Technische Universitt Mnchen (TUM)
%   Copyright: TUM
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

close all; clear all; clc

%% Read Data
% Read: Co-Registered (coarse) Master
load('MASTER_fine.mat'); %--> Master_fine

% Read: Co-Registered (fine) Slave Image
load('SLAVE_fine.mat'); %--> Slave_fine

% Read: Model Phase caused by Flat Earth
load('MODELPHASE.mat'); %--> modelphase


%% Interferogram Generation
### TBD

%% Subtraction of Model Phase caused by Flat Earth and wrapping of result
### TBD

%% Display Inteferogram reference phase and flattened interferogram
### TBD

%% Coherence Estimation
% Compute the coherence image of the selected area with defined window size (must be odd!)

% for testing: cut area around volcano
% master_test  = Master_fine(1540:2230, 390:650);
% slave_test   = Slave_fine(1540:2230, 390:650);
% modph_test   = modelphase(1540:2230, 390:650);

% 1. define window size
### TBD

% 2. define the start point in the data (for the sliding window)
% rw_start, cl_start
### TBD

% 3. define the end point in the data (for the sliding window)
% rw_end, cl_end
### TBD

% 4. calculate the complex coherence with corrected phase (flat earth phase removed)
% initialize output matrix
% coh = zeros(...TBD...)
### TBD
% loop: sliding window calculation
it = 0.1; %iterator for showing status
for kk = rw_start : rw_end
    for mm = cl_start : cl_end
        %define index into large data set (current from & to for column and row)
        % --> from_rw, to_rw
        % --> from_cl, to_cl
        ### TBD
        % calculate complex coherence estimate
        coh(kk,mm) = ### TBD

     end
     if kk/rw_end > it
         disp([ num2str(it.*100) '% done...'])
         it = it+0.1;
     end         
end


%% display the computed coherence and multi-looked interferogram
### TBD
